diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/core/model/type-id.cc ns-3.44/src/core/model/type-id.cc
--- ns-3.43/src/core/model/type-id.cc	2024-10-09 16:41:09.864655700 -0700
+++ ns-3.44/src/core/model/type-id.cc	2025-03-09 16:55:49.363371100 -0700
@@ -18,8 +18,8 @@
 #include <vector>
 
 /**
- * \file
- * \ingroup object
+ * @file
+ * @ingroup object
  * ns3::TypeId and ns3::IidManager implementations.
  */
 
@@ -36,13 +36,13 @@
 // to find g_log
 
 /**
- * \ingroup object
- * \brief TypeId information manager
+ * @ingroup object
+ * @brief TypeId information manager
  *
  * Information records are stored in a vector.  Name and hash lookup
  * are performed by maps to the vector index.
  *
- * \internal
+ * @internal
  * <b>Hash Chaining</b>
  *
  * We require all types to produce distinct hashes. What if we encounter
@@ -69,109 +69,109 @@
   public:
     /**
      * Create a new unique type id.
-     * \param [in] name The name of this type id.
-     * \returns The id.
+     * @param [in] name The name of this type id.
+     * @returns The id.
      */
     uint16_t AllocateUid(std::string name);
     /**
      * Add a deprecated name for the type id.  Use of this name raises
      * a runtime warning, and only one deprecated name is supported.
-     * \param [in] uid The id.
-     * \param [in] name The deprecated name.
+     * @param [in] uid The id.
+     * @param [in] name The deprecated name.
      */
     void AddDeprecatedName(uint16_t uid, const std::string& name);
     /**
      * Set the parent of a type id.
-     * \param [in] uid The id.
-     * \param [in] parent The id of the parent.
+     * @param [in] uid The id.
+     * @param [in] parent The id of the parent.
      */
     void SetParent(uint16_t uid, uint16_t parent);
     /**
      * Set the group name of a type id.
-     * \param [in] uid The id.
-     * \param [in] groupName The group name.
+     * @param [in] uid The id.
+     * @param [in] groupName The group name.
      */
     void SetGroupName(uint16_t uid, std::string groupName);
     /**
      * Set the size of the object class referred to by this id.
-     * \param [in] uid The id.
-     * \param [in] size The object size.
+     * @param [in] uid The id.
+     * @param [in] size The object size.
      */
     void SetSize(uint16_t uid, std::size_t size);
     /**
      * Add a constructor Callback to this type id.
-     * \param [in] uid The id.
-     * \param [in] callback The Callback for the constructor.
+     * @param [in] uid The id.
+     * @param [in] callback The Callback for the constructor.
      */
     void AddConstructor(uint16_t uid, Callback<ObjectBase*> callback);
     /**
      * Mark this type id to be excluded from documentation.
-     * \param [in] uid The id.
+     * @param [in] uid The id.
      */
     void HideFromDocumentation(uint16_t uid);
     /**
      * Get a type id by name.
-     * \param [in] name The type id to find.
-     * \returns The type id.  A type id of 0 means \pname{name} wasn't found.
+     * @param [in] name The type id to find.
+     * @returns The type id.  A type id of 0 means \pname{name} wasn't found.
      */
     uint16_t GetUid(std::string name) const;
     /**
      * Get a type id by hash value.
-     * \param [in] hash The type id to find.
-     * \returns The type id.  A type id of 0 means \pname{hash} wasn't found.
+     * @param [in] hash The type id to find.
+     * @returns The type id.  A type id of 0 means \pname{hash} wasn't found.
      */
     uint16_t GetUid(TypeId::hash_t hash) const;
     /**
      * Get the name of a type id.
-     * \param [in] uid The id.
-     * \returns The name of the type id.
+     * @param [in] uid The id.
+     * @returns The name of the type id.
      */
     std::string GetName(uint16_t uid) const;
     /**
      * Get the deprecated name of a type id.
-     * \param [in] uid The id.
-     * \returns The name of the type id.
+     * @param [in] uid The id.
+     * @returns The name of the type id.
      */
     std::string GetDeprecatedName(uint16_t uid) const;
     /**
      * Get the hash of a type id.
-     * \param [in] uid The id.
-     * \returns The hash of the type id.
+     * @param [in] uid The id.
+     * @returns The hash of the type id.
      */
     TypeId::hash_t GetHash(uint16_t uid) const;
     /**
      * Get the parent of a type id.
-     * \param [in] uid The id.
-     * \returns The parent type id of the type id.
+     * @param [in] uid The id.
+     * @returns The parent type id of the type id.
      */
     uint16_t GetParent(uint16_t uid) const;
     /**
      * Get the group name of a type id.
-     * \param [in] uid The id.
-     * \returns The group name of the type id.
+     * @param [in] uid The id.
+     * @returns The group name of the type id.
      */
     std::string GetGroupName(uint16_t uid) const;
     /**
      * Get the size of a type id.
-     * \param [in] uid The id.
-     * \returns The size of the type id.
+     * @param [in] uid The id.
+     * @returns The size of the type id.
      */
     std::size_t GetSize(uint16_t uid) const;
     /**
      * Get the constructor Callback of a type id.
-     * \param [in] uid The id.
-     * \returns The constructor Callback of the type id.
+     * @param [in] uid The id.
+     * @returns The constructor Callback of the type id.
      */
     Callback<ObjectBase*> GetConstructor(uint16_t uid) const;
     /**
      * Check if a type id has a constructor Callback.
-     * \param [in] uid The id.
-     * \returns \c true if the type id has a constructor Callback.
+     * @param [in] uid The id.
+     * @returns \c true if the type id has a constructor Callback.
      */
     bool HasConstructor(uint16_t uid) const;
     /**
      * Get the total number of type ids.
-     * \returns The total number.
+     * @returns The total number.
      */
     uint16_t GetRegisteredN() const;
     /**
@@ -180,25 +180,25 @@
      * The type id value 0 indicates not registered, so there is an offset
      * of 1 between the index and the type id value.  This function converts
      * from an index to the type id value.
-     * \param [in] i The index.
-     * \returns The type id.
+     * @param [in] i The index.
+     * @returns The type id.
      */
     uint16_t GetRegistered(uint16_t i) const;
     /**
      * Record a new attribute in a type id.
-     * \param [in] uid The id.
-     * \param [in] name The name of the new attribute
-     * \param [in] help Some help text which describes the purpose of this
+     * @param [in] uid The id.
+     * @param [in] name The name of the new attribute
+     * @param [in] help Some help text which describes the purpose of this
      *             attribute.
-     * \param [in] flags Flags which describe how this attribute can be
+     * @param [in] flags Flags which describe how this attribute can be
      *             read and/or written.
-     * \param [in] initialValue The initial value for this attribute.
-     * \param [in] accessor An instance of the associated AttributeAccessor
+     * @param [in] initialValue The initial value for this attribute.
+     * @param [in] accessor An instance of the associated AttributeAccessor
      *             subclass.
-     * \param [in] checker An instance of the associated AttributeChecker
+     * @param [in] checker An instance of the associated AttributeChecker
      *             subclass.
-     * \param [in] supportLevel The support/deprecation status for this attribute.
-     * \param [in] supportMsg Upgrade hint if this attribute is no longer supported.
+     * @param [in] supportLevel The support/deprecation status for this attribute.
+     * @param [in] supportMsg Upgrade hint if this attribute is no longer supported.
      */
     void AddAttribute(uint16_t uid,
                       std::string name,
@@ -207,90 +207,90 @@
                       Ptr<const AttributeValue> initialValue,
                       Ptr<const AttributeAccessor> accessor,
                       Ptr<const AttributeChecker> checker,
-                      TypeId::SupportLevel supportLevel = TypeId::SUPPORTED,
+                      TypeId::SupportLevel supportLevel = TypeId::SupportLevel::SUPPORTED,
                       const std::string& supportMsg = "");
     /**
      * Set the initial value of an Attribute.
-     * \param [in] uid The id.
-     * \param [in] i The attribute to manipulate
-     * \param [in] initialValue The new initial value to use for this attribute.
+     * @param [in] uid The id.
+     * @param [in] i The attribute to manipulate
+     * @param [in] initialValue The new initial value to use for this attribute.
      */
     void SetAttributeInitialValue(uint16_t uid,
                                   std::size_t i,
                                   Ptr<const AttributeValue> initialValue);
     /**
      * Get the number of attributes.
-     * \param [in] uid The id.
-     * \returns The number of attributes associated to this TypeId
+     * @param [in] uid The id.
+     * @returns The number of attributes associated to this TypeId
      */
     std::size_t GetAttributeN(uint16_t uid) const;
     /**
      * Get Attribute information by index.
-     * \param [in] uid The id.
-     * \param [in] i Index into attribute array
-     * \returns The information associated to attribute whose index is \pname{i}.
+     * @param [in] uid The id.
+     * @param [in] i Index into attribute array
+     * @returns The information associated to attribute whose index is \pname{i}.
      */
     TypeId::AttributeInformation GetAttribute(uint16_t uid, std::size_t i) const;
     /**
      * Record a new TraceSource.
-     * \param [in] uid The id.
-     * \param [in] name The name of the new trace source
-     * \param [in] help Some help text which describes the purpose of this
+     * @param [in] uid The id.
+     * @param [in] name The name of the new trace source
+     * @param [in] help Some help text which describes the purpose of this
      *             trace source.
-     * \param [in] accessor A pointer to a TraceSourceAccessor which can be
+     * @param [in] accessor A pointer to a TraceSourceAccessor which can be
      *             used to connect/disconnect sinks to this trace source.
-     * \param [in] callback Fully qualified typedef name for the callback
+     * @param [in] callback Fully qualified typedef name for the callback
      *             signature.  Generally this should begin with the
      *             "ns3::" namespace qualifier.
-     * \param [in] supportLevel The support/deprecation status for this attribute.
-     * \param [in] supportMsg Upgrade hint if this attribute is no longer supported.
+     * @param [in] supportLevel The support/deprecation status for this attribute.
+     * @param [in] supportMsg Upgrade hint if this attribute is no longer supported.
      */
     void AddTraceSource(uint16_t uid,
                         std::string name,
                         std::string help,
                         Ptr<const TraceSourceAccessor> accessor,
                         std::string callback,
-                        TypeId::SupportLevel supportLevel = TypeId::SUPPORTED,
+                        TypeId::SupportLevel supportLevel = TypeId::SupportLevel::SUPPORTED,
                         const std::string& supportMsg = "");
     /**
      * Get the number of Trace sources.
-     * \param [in] uid The id.
-     * \returns The number of trace sources defined in this TypeId.
+     * @param [in] uid The id.
+     * @returns The number of trace sources defined in this TypeId.
      */
     std::size_t GetTraceSourceN(uint16_t uid) const;
     /**
      * Get the trace source by index.
-     * \param [in] uid The id.
-     * \param [in] i Index into trace source array.
-     * \returns Detailed information about the requested trace source.
+     * @param [in] uid The id.
+     * @param [in] i Index into trace source array.
+     * @returns Detailed information about the requested trace source.
      */
     TypeId::TraceSourceInformation GetTraceSource(uint16_t uid, std::size_t i) const;
     /**
      * Check if this TypeId should not be listed in documentation.
-     * \param [in] uid The id.
-     * \returns \c true if this TypeId should be hidden from the user.
+     * @param [in] uid The id.
+     * @returns \c true if this TypeId should be hidden from the user.
      */
     bool MustHideFromDocumentation(uint16_t uid) const;
 
   private:
     /**
      * Check if a type id has a given TraceSource.
-     * \param [in] uid The id.
-     * \param [in] name The TraceSource name.
-     * \returns \c true if \pname{uid} has the TraceSource \pname{name}.
+     * @param [in] uid The id.
+     * @param [in] name The TraceSource name.
+     * @returns \c true if \pname{uid} has the TraceSource \pname{name}.
      */
     bool HasTraceSource(uint16_t uid, std::string name);
     /**
      * Check if a type id has a given Attribute.
-     * \param [in] uid The id.
-     * \param [in] name The Attribute name.
-     * \returns \c true if \pname{uid} has the Attribute \pname{name}.
+     * @param [in] uid The id.
+     * @param [in] name The Attribute name.
+     * @returns \c true if \pname{uid} has the Attribute \pname{name}.
      */
     bool HasAttribute(uint16_t uid, std::string name);
     /**
      * Hashing function.
-     * \param [in] name The type id name.
-     * \returns The hashed value of \pname{name}.
+     * @param [in] name The type id name.
+     * @returns The hashed value of \pname{name}.
      */
     static TypeId::hash_t Hasher(const std::string name);
 
@@ -330,8 +330,8 @@
 
     /**
      * Retrieve the information record for a type.
-     * \param [in] uid The id.
-     * \returns The information record.
+     * @param [in] uid The id.
+     * @returns The information record.
      */
     IidManager::IidInformation* LookupInformation(uint16_t uid) const;
 
@@ -370,14 +370,14 @@
 }
 
 /**
- * \ingroup object
- * \internal
+ * @ingroup object
+ * @internal
  * IidManager shorthand for use in NS_LOG
  */
 #define IID "IidManager"
 /**
- * \ingroup object
- * \internal
+ * @ingroup object
+ * @internal
  * IidManager shorthand for use in NS_LOG
  */
 #define IIDL IID << ": "
@@ -444,7 +444,7 @@
     information.size = (std::size_t)(-1);
     information.hasConstructor = false;
     information.mustHideFromDocumentation = false;
-    information.supportLevel = TypeId::SUPPORTED;
+    information.supportLevel = TypeId::SupportLevel::SUPPORTED;
     m_information.push_back(information);
     std::size_t tuid = m_information.size();
     NS_ASSERT(tuid <= 0xffff);
@@ -973,12 +973,12 @@
     auto [found, tid, attribute] = FindAttribute(*this, name);
     if (found)
     {
-        if (attribute.supportLevel == TypeId::SUPPORTED)
+        if (attribute.supportLevel == SupportLevel::SUPPORTED)
         {
             *info = attribute;
             return true;
         }
-        else if (attribute.supportLevel == TypeId::DEPRECATED)
+        else if (attribute.supportLevel == SupportLevel::DEPRECATED)
         {
             if (!permissive)
             {
@@ -988,7 +988,7 @@
             *info = attribute;
             return true;
         }
-        else if (attribute.supportLevel == TypeId::OBSOLETE)
+        else if (attribute.supportLevel == SupportLevel::OBSOLETE)
         {
             NS_FATAL_ERROR("Attribute '"
                            << name << "' is obsolete, with no fallback: " << attribute.supportMsg);
@@ -1240,19 +1240,19 @@
             tmp = tid.GetTraceSource(i);
             if (tmp.name == name)
             {
-                if (tmp.supportLevel == TypeId::SUPPORTED)
+                if (tmp.supportLevel == SupportLevel::SUPPORTED)
                 {
                     *info = tmp;
                     return tmp.accessor;
                 }
-                else if (tmp.supportLevel == TypeId::DEPRECATED)
+                else if (tmp.supportLevel == SupportLevel::DEPRECATED)
                 {
                     std::cerr << "TraceSource '" << name << "' is deprecated: " << tmp.supportMsg
                               << std::endl;
                     *info = tmp;
                     return tmp.accessor;
                 }
-                else if (tmp.supportLevel == TypeId::OBSOLETE)
+                else if (tmp.supportLevel == SupportLevel::OBSOLETE)
                 {
                     NS_FATAL_ERROR("TraceSource '" << name << "' is obsolete, with no fallback: "
                                                    << tmp.supportMsg);
@@ -1286,10 +1286,10 @@
 }
 
 /**
- * \brief Insertion operator for TypeId
- * \param [in] os the output stream
- * \param [in] tid the TypeId
- * \returns the updated output stream.
+ * @brief Insertion operator for TypeId
+ * @param [in] os the output stream
+ * @param [in] tid the TypeId
+ * @returns the updated output stream.
  */
 std::ostream&
 operator<<(std::ostream& os, TypeId tid)
@@ -1299,10 +1299,10 @@
 }
 
 /**
- * \brief Extraction operator for TypeId
- * \param [in] is the input stream
- * \param [out] tid the TypeId value
- * \returns the updated input stream.
+ * @brief Extraction operator for TypeId
+ * @param [in] is the input stream
+ * @param [out] tid the TypeId value
+ * @returns the updated input stream.
  */
 std::istream&
 operator>>(std::istream& is, TypeId& tid)
@@ -1317,6 +1317,21 @@
     return is;
 }
 
+std::ostream&
+operator<<(std::ostream& os, TypeId::SupportLevel level)
+{
+    switch (level)
+    {
+    case TypeId::SupportLevel::SUPPORTED:
+        return os << "SUPPORTED";
+    case TypeId::SupportLevel::DEPRECATED:
+        return os << "DEPRECATED";
+    case TypeId::SupportLevel::OBSOLETE:
+        return os << "OBSOLETE";
+    };
+    return os << "UNKNOWN(" << static_cast<uint32_t>(level) << ")";
+}
+
 ATTRIBUTE_HELPER_CPP(TypeId);
 
 bool
